'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _contract_wrapper = require('./contract_wrapper');

var _contract_wrapper2 = _interopRequireDefault(_contract_wrapper);

var _web3_tools = require('../utils/web3_tools');

var _contract_jsons = require('../contract_jsons');

var _contract_jsons2 = _interopRequireDefault(_contract_jsons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PoolsNodesManagerWrapper = function (_ContractWrapper) {
  (0, _inherits3.default)(PoolsNodesManagerWrapper, _ContractWrapper);

  function PoolsNodesManagerWrapper(contractAddress, web3, defaultAddress) {
    (0, _classCallCheck3.default)(this, PoolsNodesManagerWrapper);

    var _this = (0, _possibleConstructorReturn3.default)(this, (PoolsNodesManagerWrapper.__proto__ || Object.getPrototypeOf(PoolsNodesManagerWrapper)).call(this, web3, defaultAddress));

    _this.address = contractAddress;
    _this.contract = (0, _web3_tools.loadContract)(web3, _contract_jsons2.default.poolsNodesManager.abi, contractAddress);
    return _this;
  }

  (0, _createClass3.default)(PoolsNodesManagerWrapper, [{
    key: 'poolsNodesCreated',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(fromBlock, toBlock) {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt('return', this.contract.getPastEvents('PoolNodeCreated', { fromBlock: fromBlock, toBlock: toBlock }));

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function poolsNodesCreated(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return poolsNodesCreated;
    }()
  }, {
    key: 'poolsNodesOnboarded',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(fromBlock, toBlock) {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt('return', this.contract.getPastEvents('PoolNodeOnboarded', { fromBlock: fromBlock, toBlock: toBlock }));

              case 1:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function poolsNodesOnboarded(_x3, _x4) {
        return _ref2.apply(this, arguments);
      }

      return poolsNodesOnboarded;
    }()
  }, {
    key: 'poolsNodesRetired',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(fromBlock, toBlock) {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt('return', this.contract.getPastEvents('PoolNodeRetired', { fromBlock: fromBlock, toBlock: toBlock }));

              case 1:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function poolsNodesRetired(_x5, _x6) {
        return _ref3.apply(this, arguments);
      }

      return poolsNodesRetired;
    }()
  }]);
  return PoolsNodesManagerWrapper;
}(_contract_wrapper2.default); /*
                               Copyright: Ambrosus Inc.
                               Email: tech@ambrosus.io
                               
                               This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.
                               
                               This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
                               */

exports.default = PoolsNodesManagerWrapper;